import {
    createDefaultModule, createDefaultSharedModule, DefaultSharedModuleContext, inject,
    LangiumServices, LangiumSharedServices, Module, PartialLangiumServices
} from 'langium';
import { CustomScopeComputation } from './stairway-scope';
import { StairwayGeneratedModule, StairwayGeneratedSharedModule } from './generated/module';
import { StairwayValidator, registerValidationChecks } from './stairway-validator';

/**
 * Declaration of custom services - add your own service classes here.
 */
export type StairwayAddedServices = {
    validation: {
        StairwayValidator: StairwayValidator
    }
}

/**
 * Union of Langium default services and your custom services - use this as constructor parameter
 * of custom service classes.
 */
export type StairwayServices = LangiumServices & StairwayAddedServices

/**
 * Dependency injection module that overrides Langium default services and contributes the
 * declared custom services. The Langium defaults can be partially specified to override only
 * selected services, while the custom services must be fully specified.
 */
export const StairwayModule: Module<StairwayServices, PartialLangiumServices & StairwayAddedServices> = {
    references:{
        ScopeComputation: (services) => new CustomScopeComputation(services)
    },
    validation: {
        StairwayValidator: () => new StairwayValidator()
    }
};





/**
 * Create the full set of services required by Langium.
 *
 * First inject the shared services by merging two modules:
 *  - Langium default shared services
 *  - Services generated by langium-cli
 *
 * Then inject the language-specific services by merging three modules:
 *  - Langium default language-specific services
 *  - Services generated by langium-cli
 *  - Services specified in this file
 *
 * @param context Optional module context with the LSP connection
 * @returns An object wrapping the shared services and the language-specific services
 */
export function createStairwayServices(context: DefaultSharedModuleContext): {
    shared: LangiumSharedServices,
    Stairway: StairwayServices
} {
    const shared = inject(
        createDefaultSharedModule(context),
        StairwayGeneratedSharedModule
    );
    const Stairway = inject(
        createDefaultModule({ shared }),
        StairwayGeneratedModule,
        StairwayModule
    );
    shared.ServiceRegistry.register(Stairway);
    registerValidationChecks(Stairway);
    return { shared, Stairway };
}
